package cokr.xit.fims.sprt.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.sprt.CvlcptDscsnCn;
import cokr.xit.fims.sprt.SprtQuery;
import cokr.xit.fims.sprt.dao.CvlcptDscsnCnMapper;

/**민원 상담 내용 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-09-05	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("sprt04Bean")
public class Sprt04Bean extends AbstractComponent {

	/** 민원 상담 내용 정보 DAO */
	@Resource(name = "cvlcptDscsnCnMapper")
	private CvlcptDscsnCnMapper cvlcptDscsnCnMapper;

	/**지정한 조건에 따라 민원 상담 내용 목록을 조회하여 반환한다.
	 * @param req 민원 상담 내용 조회 조건
	 * @return 민원 상담 내용 목록
	 */
	public List<DataObject> getCvlcptDscsnCnList(SprtQuery req) {
		return cvlcptDscsnCnMapper.selectCvlcptDscsnCnList(req);
	}

	/**지정한 조건에 따라 민원 상담 내용 객체들을 반환한다.
	 * @param req 민원 상담 내용 조회 조건
	 * @return 민원 상담 내용 객체 목록
	 */
	public List<DataObject> getCvlcptDscsnCns(SprtQuery req) {
		if (req.getOrderBy() == null) {
			req.setOrderBy("CDC.REG_DT DESC");
		}

		return cvlcptDscsnCnMapper.selectCvlcptDscsnCns(req);
	}

	/**지정한 민원 상담 ID의 민원 상담 내용 정보를 반환한다.<br />
	 * @param cvlcptDscsnId 민원 상담 ID
	 * @return 민원 상담 내용 정보
	 */
	public DataObject getCvlcptDscsnCnInfo(SprtQuery req) {
		return cvlcptDscsnCnMapper.selectCvlcptDscsnCnInfo(req);
	}

	/**지정한 단속 ID의 단속 정보를 반환한다.<br />
	 * @param crndId 단속 ID
	 * @return 단속 정보
	 */
	public DataObject getCrdnInfo(SprtQuery req) {
		return cvlcptDscsnCnMapper.selectCrdn(req);
	}

	/**민원 상담 내용 정보를 등록한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String createCvlcptDscsnCn(CvlcptDscsnCn cvlcptDscsnCn) {
		// 변수 선언
		boolean retSuccess = false;						// DB 처리 결과
		String retMessage = "";							// 처리 결과 메시지

		if (cvlcptDscsnCn.getCvlcptRcptSeCd().equals("01")) {
			cvlcptDscsnCn.setVhrno(null);
			cvlcptDscsnCn.setRtpyrNo(null);
		} else if (cvlcptDscsnCn.getCvlcptRcptSeCd().equals("02")) {
			cvlcptDscsnCn.setRtpyrNo(null);
		} else if (cvlcptDscsnCn.getCvlcptRcptSeCd().equals("03")) {
			cvlcptDscsnCn.setVhrno(null);
		}

		retSuccess = cvlcptDscsnCnMapper.insert(cvlcptDscsnCn);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 DB Rollback
			throw new RuntimeException("민원상담내용 대장 등록에 실패하였습니다.");
		}

		retMessage = "[S] 작업이 정상 처리 되었습니다.";

		return retMessage;
	}

	/**민원 상담 내용 정보를 수정한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String updateCvlcptDscsnCn(CvlcptDscsnCn cvlcptDscsnCn) {
		// 변수 선언
		boolean retSuccess = false;						// DB 처리 결과
		String retMessage = "";							// 처리 결과 메시지

		retSuccess = cvlcptDscsnCnMapper.update(cvlcptDscsnCn);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 DB Rollback
			throw new RuntimeException("민원상담내용 대장 수정에 실패하였습니다.");
		}

		retMessage = "[S] 작업이 정상 처리 되었습니다.";

		return retMessage;
	}

	/**민원 상담 내용 정보를 삭제한다.
	 * @param cvlcptDscsnCn 민원 상담 내용
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String removeCvlcptDscsnCn(CvlcptDscsnCn cvlcptDscsnCn) {
		// 변수 선언
		boolean retSuccess = false;						// DB 처리 결과
		String retMessage = "";							// 처리 결과 메시지

		retSuccess = cvlcptDscsnCnMapper.delete(cvlcptDscsnCn);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 DB Rollback
			throw new RuntimeException("민원상담내용 대장 삭제에 실패하였습니다.");
		}

		retMessage = "[S] 작업이 정상 처리 되었습니다.";

		return retMessage;
	}

}
